package de.cnc;

import javax.servlet.ServletContext;
import javax.servlet.http.*;

import de.cnc.util.StringUtil;

/**
 * Diese Klasse enthlt allgemeine Kontext-Informationen
 * 
 * @author Heiner Kcker
 * @since 09.09.2004
 */
public class CncContext
{
   /**
    * Konstruktor private
    */
//   private CncContext()
//   {
//      ;
//   }

   private final HttpServletRequest request;
   
   private final HttpServletResponse response;
   
   private final HttpSession session;
   
   private final ServletContext application;

   /**
    * User-ID als String
    */
   private String userId;

    /**
     * CnC-Action aus HTML-Form &lt;form action="..." ... 
     * bzw. HTML-Link &lt;a hef="..." ...
     */
    private String action;

    private boolean noValidate;

   /**
    * Konstruktor mit Initialisierungswerten
    * 
    * @param session
    */
   public CncContext(
      final HttpServletRequest pRequest,
      final HttpServletResponse pResponse,
      final HttpSession pSession,
      final ServletContext pApplication,
      final String pAction,
      final boolean pNoValidate)
   {
      this.request = pRequest;
      this.response = pResponse;
      this.session = pSession;
      this.application = pApplication;
      this.setUserId( StringUtil.upper( (String) session.getAttribute( "USER" ) ) ); //@todo: Konstante machen
      if (this.userId == null)
      {
         this.userId = "???";
      }
      action = pAction;
      noValidate = pNoValidate;
   }

   /**
    * @return
    */
   public String getUserId()
   {
      return userId;
   }

   /**
    * @param pString
    */
   public void setUserId(String pString)
   {
      userId = pString;
   }

   /**
    * @return
    */
   public ServletContext getApplication()
   {
      return application;
   }

   /**
    * @return
    */
   public HttpServletRequest getRequest()
   {
      return request;
   }

   /**
    * @return
    */
   public HttpServletResponse getResponse()
   {
      return response;
   }

   /**
    * @return
    */
   public HttpSession getSession()
   {
      return session;
   }

    /**
     * @return
     */
    public String getAction()
    {
        return action;
    }

    /**
     * @param string
     */
    public void setAction(String string)
    {
        action = string;
    }

    /**
     * 
     */
    public boolean getNoValidate()
    {
        return noValidate;
    }

}
