package de.cnc;


/**
 * statischer Anker auf das zentrale CncServlet zur allgemeinen Verwendung . <br/>
 * Wird verwendet in {@link de.rewe.arf.taglib.CheckUserTag} zum Zugriff auf die Methode
 * {@link de.cnc.CncServlet#hasUserPermissionForJsp} zum User-Check.
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id:$
 */
public class CncServletAnchor {

  /**
   * statischer Anker
   */
  private static CncServlet cncServlet;

  /**
   * get cncServlet
   *
   * @return cncServlet
   */
  public static CncServlet getCncServlet() {
    return cncServlet;
  }// end method getCncServlet

  /**
   * set cncServlet
   *
   * @param cncServlet new Value
   */
  public static synchronized void setCncServlet(CncServlet newCncServlet) {
    cncServlet = newCncServlet;
  }// end method setCncServlet

}// end class CncServletAnchor
