package de.cnc;

/**
 * Struktur fr Quelltext-Zeilen des Steuerfiles <b>flow.cnc</b> als Array . <br/>
 * Wird hauptschlich fr das Debugging bentigt.<br/>
 * @see FlowControlCompiler
 * @see FlowControl
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id:$
 */
public final class FlowSrcFileLine {

  /**
   * Adresse in {@link FlowControlTable} , -1 steht fr Adresse undefiniert (Quellzeile ist nicht mit einem Befehl assoziiert)
   */
  public int adr = -1;

  /**
   * Zeile HTML-encodet
   */
  public String lineEncodet;

  /**
   *  Zeile nicht HTML-encodet
   */
  public String lineNotEncodet;

  /**
   * Name der Prozedur, zu welcher dieser Zeile gehrt
   */
  public String procName;

  /**
   * Zeile wie ausgegeben: HTML-encodet mit Source-Line-Number und Adresse
   */
  public String lineOut;

}// end class FlowSrcFileLine
