package de.cnc;

import javax.servlet.http.HttpServletRequest;

import de.cnc.validator.FormFieldErrorMap;

/**
 * Interface zur Form-Validierung . <br/>
 * Vom {@link de.cnc.CncServlet} werden die
 * Validierungsmethoden aufgerufen, wenn
 * die FormBean dieses Interface implementiert.
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public interface FormValidatorInterface
{
    /** 
     * Prfen auf Validitt vor dem Einparsen des Browser-Request 
     * @return ob der Request valid ist
     */
//    public boolean isRequestValid(
//        final HttpServletRequest request);
    
    /** 
     * Prfen auf Validitt nach dem Einparsen des Browser-Request 
     * @return ob der Inhalt der Form-Bean valid ist
     */
    public boolean isBeanValid( //--
        final HttpServletRequest request, //--
        final FormFieldErrorMap pErrMap);

}
