package de.cnc.domainparser;


import de.cnc.domainparser.util.SourcePosition;


/**
 * @author
 */
public class DomainParseException extends Exception
{

    final SourcePosition srcPos;

    /**
     * Konstruktor protected, um bergabe der Source-Position zu erzwingen
     * 
     * @param pStr
     */
    // protected DomainParseException(String pStr)
    // {
    // super( pStr );   
    // }

    /**
     * @param
     */
    public DomainParseException(String pStr, SourcePosition pSrcPos)
    {
        super(pStr);
        srcPos = pSrcPos.getClone();
    }

    /**
     * @see java.lang.Throwable#getMessage()
     */
    public String getMessage()
    {
        return super.getMessage() + " " + " pos: " + srcPos.getPos() + " row: " + srcPos.getRow()
                + " col: " + srcPos.getCol();
    }

}

