package de.cnc.expression;

// import de.cnc.expression.*;
import de.cnc.expression.exceptions.*;

public abstract class AbstractToken
{

    protected int iLine;
    protected int iCol;
    protected String strSource;
    protected int iSrcLength = 0;
    protected String strOriginalSource;

    // public AbstractToken(String paStr, int paIntLine, int paIntCol) {
    // strSource = paStr;
    public AbstractToken(
        String paStrOriginalSource,
        int paIntLine,
        int paIntCol)
    {
        strOriginalSource = paStrOriginalSource;
        strSource = paStrOriginalSource; // hier mal ordentlich nacharbeiten
        iLine = paIntLine;
        iCol = paIntCol;
    }

    /**
     * gets the the source line number
     */
    public int getLine()
    {
        return iLine;
    }

    /**
     * gets the col position in the source code line
     */
    public int getCol()
    {
        return iCol;
    }

    public String getSource()
    {
        return strSource;
    }

    public int getSrcLength()
    {
        return iSrcLength;
    }

    public String getOriginalSource()
    {
        return strOriginalSource;
    }

    /**
     * get the wahrscheinlichen return typen . <br>
     * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
     * null wenn kein Rckgabe-Wert,
     * mehrere wenn mehrere mglich
     * ( z.B. Plus-Operator kann numerisch oder String liefern)
     */
    // abstract public int[] getCheckReturnTypes(AbstractRuntimeEnvironment paRunEnv) ;
    abstract public int[] getCheckReturnTypes()
        throws ExpressionParseException;

    /**
     * rekursives Aufrufen der Klammerung der Ausdrcke
     * entsprechend der Operator-Prioritt.
     */
    abstract public void organizeOperatorPriority();

    /**
     * process the token
     */
    abstract public Object eval(AbstractRuntimeEnvironment paRunEnv)
        throws ExpressionEvaluationException;

    /**
     * process the token
     */
    // abstract public  void checkTypes(AbstractRuntimeEnvironment paRunEnv) throws ExpressionParseException;

    /**
     * @param i
     */
    public void setCol(int i)
    
    {
        iCol = i;
    }

    /**
     * @param i
     */
    public void setLine(int i)
    {
        iLine = i;
    }

} // end class
