package de.cnc.expression;

import de.cnc.expression.exceptions.ExpressionEvaluationException;

/**
 * Interface fr zuweisbare Ausdrcke wie
 * Variable, Indexausdrcke und Object-Attribute.
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public interface Assignable
{

    /**
     * get value
     */
    public Object eval(AbstractRuntimeEnvironment paRunEnv)
        throws ExpressionEvaluationException;

    /**
     * set value
     */
    public void set(AbstractRuntimeEnvironment paRunEnv, Object paObjValue)
        throws ExpressionEvaluationException;

    /**
     * remove value
     * @return the removed value
     */
    public Object remove(AbstractRuntimeEnvironment paRunEnv)
        throws ExpressionEvaluationException;

}
