package de.cnc.expression.assignmentoperators;


import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.Assignable;
import de.cnc.expression.exceptions.*;
import de.cnc.expression.tokencomplex.IndexOperator;
import de.cnc.expression.tokencomplex.Variable;


/**
 * Set Operator <b>:=</b>
 */
public class SetOperator extends AbstractAssignmentOperator {

  public static SetOperator parse(String paStr, int paIntLine, int paIntCol, String paStrOriginalSource)
    throws  ExpressionParseException { // , NoSuchTokenException {
    // System.out.println( "SetOperator#parse:"+paStr);
    if ((paStr.length() > 2 && paStr.startsWith(":=")
    // falsch, gibt problem bei "n1:=n2" && !Character.isLetterOrDigit(paStr.charAt(2))
    )
     || ":=".equals(paStr)) {
      SetOperator setOperator = new SetOperator(paStrOriginalSource, paIntLine, paIntCol);

      setOperator.strSource = ":=";
      setOperator.iSrcLength = 2;
      return setOperator;
    }
    return null; // throw new NoSuchTokenException(paIntLine, paIntCol, paStr, "no || operator");
  }// end method parse

  /**
   * constructor
   */
  public SetOperator(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the operator . <br>
   */
  public Object eval(Assignable paVariable, Object paObjRight, AbstractRuntimeEnvironment paRunEnv) throws ExpressionEvaluationException {
    paVariable.set(paRunEnv, paObjRight);
    return paObjRight;
  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public int[] getCheckReturnTypes(int[] paIntArrLeft, int[] paIntArrRight)  throws ExpressionParseException {
    return paIntArrRight; // Rckgabe der zu setzenden Typen
  }// end method getCheckReturnTypes

}// end class
