package de.cnc.expression.exceptions;


/**
 * wird geworfen wenn das token richtig ist, aber im token ein fehler ist
 */
public class ExpressionParseException extends Exception {

  private int iLine;
  private int iCol;
  private String strSource;

  /**
   * constructor
   */
  public ExpressionParseException(int paIntLine, int paIntCol, String paStrSource, String paStrErrorMessage) {
    super(paStrErrorMessage);
    iLine = paIntLine;
    iCol = paIntCol;
    strSource = paStrSource;
  }

  public int getLine() {
    return iLine;
  }

  public int getCol() {
    return iCol;
  }

  public String getMessage() {
    return super.getMessage() + " line:" + iLine            // line
        + " col:" + iCol + "\n"       // col
        + strSource + "\n"            // source
        + spaces(iCol) + "^\n";       // advice arrow
  }

  /**
   * liefert eine gewnschte Anzahl Leerzeichen
   */
  private static String spaces(int paIntCount) {
    StringBuffer sb = new StringBuffer();

    for (int i = 0; i < paIntCount; i++) {
      sb.append(' ');
    }
    return sb.toString();
  }

}// end class ExpressionParseException
