package de.cnc.expression.functions;


import de.cnc.expression.*;
import de.cnc.expression.exceptions.*;
import de.cnc.expression.util.TimeOut;


/**
 *  for( &lt;startExpression&gt; , &lt;booleanExpression&gt; , &lt;stepExpression&gt; , &lt;bodyExpression&gt; ) . <br>
 * ifor( &lt;startExpression&gt; , &lt;booleanExpression&gt; , &lt;stepExpression&gt; , &lt;bodyExpression&gt; ) . <br>
 * Ausfhrung der Body-Expression solange der erste Parameter true ist<br>
 */
public class ForFunction extends AbstractFunction {

  /**
   * constructor
   */
  public ForFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public Object eval(AbstractRuntimeEnvironment paRunEnv) throws ExpressionEvaluationException {
    getObjectParamNullable(paRunEnv, 0) ; // startExpression
    Object retObject = null;

    while (getBooleanParamNoNull(paRunEnv, 1).booleanValue()) { // condition
      if (TimeOut.isTimeOut()) {
        throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(), "expression timed out");
      }

      retObject = getObjectParamNullable(paRunEnv, 3); // bodyExpression
      getObjectParamNullable(paRunEnv, 2) ; // stepExpression
    }
    return retObject;
  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public int[] getCheckReturnTypes()
    throws ExpressionParseException {
    checkParamCount(4);

    checkParameterForBoolean(0);

    return new int[] {Types.RET_TYPE_UNKNOWN };
  }// end method getCheckReturnTypes

} // end class
