package de.cnc.expression.functions;


import de.cnc.expression.*;
import de.cnc.expression.exceptions.*;


/**
 *  if( &lt;booleanExpression&gt; , &lt;trueExpression&gt; , &lt;falseExpression&gt; ) . <br>
 * iif( &lt;booleanExpression&gt; , &lt;trueExpression&gt; , &lt;falseExpression&gt; ) . <br>
 * mit verkrzter Auswertung (Short-Circuit-Evaluation)<br>
 */
public class IfFunction extends AbstractFunction {

  /**
   * constructor
   */
  public IfFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public Object eval(AbstractRuntimeEnvironment paRunEnv) throws ExpressionEvaluationException {
    boolean bFirst = getBooleanParamNoNull(paRunEnv, 0).booleanValue();

    if (bFirst) {
      return getObjectParamNullable(paRunEnv, 1);
    }
    else {
      return getObjectParamNullable(paRunEnv, 2);
    }
  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public int[] getCheckReturnTypes()
    throws ExpressionParseException {
    checkParamCount(3);

    checkParameterForBoolean(0);

    return new int[] {Types.RET_TYPE_UNKNOWN };
  }// end method getCheckReturnTypes

} // end class
