package de.cnc.expression.functions;


import de.cnc.expression.*;
import de.cnc.expression.exceptions.*;


/**
 * isValid( &lt;valueString&gt; ) . <br>
 * Prft, ob der bergebene String ohne Fehler kompiliert werden kann.<br>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class IsValidFunction extends AbstractFunction {

  /**
   * constructor
   */
  public IsValidFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public Object eval(AbstractRuntimeEnvironment paRunEnv) throws ExpressionEvaluationException {
    String strValue = getStringParamNoNull(paRunEnv, 0);

    try {
      Expression.parseStrict(strValue, paramList.get(0).getLine(), paramList.get(0).getCol());
      // kompilieren hat geklappt
      return Boolean.TRUE ;
    } catch (ExpressionParseException e) {// System.out.println( ""+e ) ;
      // throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(), "" + e);
      // return "";
    }
    // kompilieren hat nicht geklappt
    return Boolean.FALSE ;

  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public int[] getCheckReturnTypes()
    throws ExpressionParseException {
    checkParamCount(1);
    checkParameterForString(0);
    return new int[] {Types.RET_TYPE_EXPRESSION };
  }// end method getCheckReturnTypes

} // end class
