package de.cnc.expression.functions;


import de.cnc.expression.*;
import de.cnc.expression.exceptions.*;


/**
 * ?? noch fertig amchen ?? newStringArray( &lt;numSize&gt; )<br>
 * newStringArray( &lt;str[0]&gt; [ , &lt;str[n]&gt; ] )<br>
 * Erzeugt ein
 *
 *  Objekt
 *
 * neues String-Array in der verlangten Grsse (numerischer Parameter)
 * oder aus der bergebenen String-Parameter-Liste.<br>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class NewObjectFunction extends AbstractFunction
{

   /**
    * constructor
    */
   public NewObjectFunction(String paStrOriginalSource, int paIntLine, int paIntCol)
   {
      super(paStrOriginalSource, paIntLine, paIntCol);
   }// end constructor

   /**
    * process the token
    */
   public Object eval(AbstractRuntimeEnvironment paRunEnv) throws ExpressionEvaluationException
   {
      String strValue = getStringParamNoNull(paRunEnv, 0);

         Class cla = null;

         try
         {
            cla = Class.forName(strValue);
         }
         catch (ClassNotFoundException cnfe)
         {
            throw new ExpressionEvaluationException(getLine(), getCol(), getSource(),
                  getOriginalSource(), cnfe.getMessage() + " " + strValue);
         }
         try
         {
            Object retObject = cla.newInstance();

            // evtl. spter mit mehreren Parametern
            return retObject;
         }
         catch (IllegalAccessException iae)
         {
            throw new ExpressionEvaluationException(getLine(), getCol(), getSource(),
                  getOriginalSource(), iae.getMessage() + " " + cla);
         }
         catch (InstantiationException iae)
         {
            throw new ExpressionEvaluationException(getLine(), getCol(), getSource(),
                  getOriginalSource(), iae.getMessage() + " " + cla);
         }
   }// end method eval

   /**
    * get the wahrscheinlichen return typen . <br>
    * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
    * null wenn kein Rckgabe-Wert,
    * mehrere wenn mehrere mglich
    * ( z.B. Plus-Operator kann numerisch oder String liefern)
    */
   public int[] getCheckReturnTypes()
      throws ExpressionParseException
   {
      checkParamCount(1);
      checkParameterForString(0);
      return new int[] {Types.RET_TYPE_UNKNOWN };
   }// end method getCheckReturnTypes

} // end class
