package de.cnc.expression.functions;


import de.cnc.expression.*;
import de.cnc.expression.exceptions.*;
import de.cnc.expression.util.OutPrintStream;


/**
 * println( &lt;objectvalue&gt; ) . <br>
 * Ausgabe des als Parameter bergebenen Ausdruckes auf System.out mit Zeilenumbruch
 * Zurckgegeben wird der ausgegebene Ausdruck.<br>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class PrintlnFunction extends AbstractFunction {

  /**
   * constructor
   */
  public PrintlnFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public Object eval(AbstractRuntimeEnvironment paRunEnv) throws ExpressionEvaluationException {
    Object objValue = getObjectParamNullable(paRunEnv, 0);

    // System.out.println( "" + objValue ) ;
    // umgelenkter Stream fr Online Tester
    OutPrintStream.getOut().println("" + objValue);
    return objValue;
  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public int[] getCheckReturnTypes()
    throws ExpressionParseException {
    checkParamCount(1);

    return new int[] {Types.RET_TYPE_BOOL };
  }// end method getCheckReturnTypes

} // end class
