package de.cnc.expression.functions;

import java.util.List;

import de.cnc.expression.*;
import de.cnc.expression.exceptions.*;
import de.cnc.util.StringUtil;

/**
 * remove( &lt;List or Array&gt; , &lt;value&gt; [ , &lt;index&gt; ] ) . <br>
 * Entfernen eines Wertes aus einer {@link java.util.List} oder einem Array 
 */
public class RemoveFunction extends AbstractFunction
{

   /**
    * constructor
    */
   public RemoveFunction(String paStrOriginalSource, int paIntLine, int paIntCol)
   {
      super(paStrOriginalSource, paIntLine, paIntCol);
   } // end constructor

   /**
    * process the token
    */
   public Object eval(AbstractRuntimeEnvironment paRunEnv) throws ExpressionEvaluationException
   {
//     Object oListOrArray = paramList.get(0).eval(paRunEnv);
//     if (oListOrArray == null)
//     {
//        throw new ExpressionEvaluationException(
//           getLine(),
//           getCol(),
//           getSource(),
//           getOriginalSource(),
//           "first parameter missed");
//     }
     Object oListOrArray = getObjectParamNoNull(paRunEnv, 0);

      Number listIndex = getNumberParamNoNull(paRunEnv, 1);
      //Object delInxObj = paramList.get(1).eval(paRunEnv);

      if ( oListOrArray instanceof List )
      {
         List oList = (List) oListOrArray;
         oList.remove( listIndex.intValue() );
         return oList;
      }
      if ( oListOrArray.getClass().isArray() )
      {
         Object[] oArr = (Object[]) oListOrArray;
         Object[] retArr = StringUtil.arrRemove( oArr , listIndex.intValue() );
         return retArr;
      }
      else
      {
         throw new ExpressionEvaluationException(
            getLine(),
            getCol(),
            getSource(),
            getOriginalSource(),
            "list or array expected");
      }

      //try
      //{
      //   Object oValue = paramList.get(1).eval(paRunEnv);

      //   return oValue;
      //}
      //catch (Exception e)
      //{
      //   throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(), "" + e);
      //}

   } // end method eval

   /**
    * get the wahrscheinlichen return typen . <br>
    * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
    * null wenn kein Rckgabe-Wert,
    * mehrere wenn mehrere mglich
    * ( z.B. Plus-Operator kann numerisch oder String liefern)
    */
   public int[] getCheckReturnTypes() throws ExpressionParseException
   {
      checkParamCount(2);

      checkParameterForListOrArray(0);

      checkParameterForNumber(1);
      
      return new int[] { Types.RET_TYPE_LIST_OR_ARRAY };
   } // end method getCheckReturnTypes

} // end class
