package de.cnc.expression.functions;


import de.cnc.expression.*;
import de.cnc.expression.exceptions.*;


/**
 * spaces( &lt;valueNumber&gt; ) . <br>
 * liefert einen String aus Leerzeichen in gewnschten der Lnge
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class SpacesFunction extends AbstractFunction {

  /**
   * constructor
   */
  public SpacesFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public Object eval(AbstractRuntimeEnvironment paRunEnv) throws ExpressionEvaluationException {
    Number numCount = getNumberParamNoNull(paRunEnv, 0);

    try {

      return spaces(numCount.intValue()) ;
    } catch (Exception e) {
      // System.out.println( ""+e ) ;
      // throw new ExpressionEvaluationException(getLine(), getCol(),getSource() , getOriginalSource(), "" + e);
      return "";
    }

  }// end method eval

  /**
   * liefert eine gewnschte Anzahl Leerzeichen
   */
  private static String spaces(int paIntCount) {
    StringBuffer sb = new StringBuffer();

    for (int i = 0; i < paIntCount; i++) {
      sb.append(' ');
    }
    return sb.toString();
  }// end methoh spaces

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public int[] getCheckReturnTypes()
    throws ExpressionParseException {
    checkParamCount(1);

    checkParameterForNumber(0);

    return new int[] {Types.RET_TYPE_STRING };
  }// end method getCheckReturnTypes

} // end class
