package de.cnc.expression.functions;

import de.cnc.expression.*;
import de.cnc.expression.exceptions.*;
import de.cnc.util.StringUtil;


/**
 * str( &lt;valueNumber&gt; ) . <br>
 * wandelt einen String 'dd.MM.yyyy' in einen String um
 * oder liefert 'null' wenn ungltig.
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class StrToDateFunction 
    extends AbstractFunction 
{

  /**
   * constructor
   */
  public StrToDateFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public Object eval(AbstractRuntimeEnvironment paRunEnv) 
    throws ExpressionEvaluationException 
  {
    String inputStr = getStringParamNoNull(paRunEnv, 0);

    try {

      return StringUtil.parseDateCatched( inputStr );
    } catch (Exception e) {
      // System.out.println( ""+e ) ;
      // throw new ExpressionEvaluationException(getLine(), getCol(),getSource() , getOriginalSource(), "" + e);
      return "";
    }

  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public int[] getCheckReturnTypes()
    throws ExpressionParseException {
    checkParamCount(1);

    checkParameterForString(0);

    return new int[] {Types.RET_TYPE_DATE, Types.RET_TYPE_NULL };
  }// end method getCheckReturnTypes

} // end class
