package de.cnc.expression.functions;


import de.cnc.expression.*;
import de.cnc.expression.exceptions.*;
import de.cnc.expression.util.TimeOut;


/**
 *  while( &lt;booleanExpression&gt; , &lt;bodyExpression&gt; ) . <br>
 * iwhile( &lt;booleanExpression&gt; , &lt;bodyExpression&gt; ) . <br>
 * Ausfhrung der Body-Expression solange der erste Parameter true ist<br>
 */
public class WhileFunction extends AbstractFunction {

  /**
   * constructor
   */
  public WhileFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public Object eval(AbstractRuntimeEnvironment paRunEnv) throws ExpressionEvaluationException {
    Object retObject = null;

    while (getBooleanParamNoNull(paRunEnv, 0).booleanValue()) {
      if (TimeOut.isTimeOut()) {
        throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(), "expression timed out");
      }

      retObject = getObjectParamNullable(paRunEnv, 1);
    }
    return retObject;
  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public int[] getCheckReturnTypes()
    throws ExpressionParseException {
    checkParamCount(2);

    checkParameterForBoolean(0);

    return new int[] {Types.RET_TYPE_UNKNOWN };
  }// end method getCheckReturnTypes

} // end class
