package de.cnc.expression.infixoperators;


import java.math.BigDecimal;

import de.cnc.expression.exceptions.*;


public class PotentizeOperator extends AbstractInfixOperator {

  public static PotentizeOperator parse(String paStr, int paIntLine, int paIntCol, String paStrOriginalSource)
    throws  ExpressionParseException { // , NoSuchTokenException {
    // System.out.println( "PotentizeOperator#parse:"+paStr);
    if (paStr.startsWith("**")) {
      PotentizeOperator potentizeOp = new PotentizeOperator(paStrOriginalSource, paIntLine, paIntCol);

      potentizeOp.strSource = "**";
      potentizeOp.iSrcLength = 2;

      return potentizeOp;
    }
    if (paStr.startsWith("^")) {
      PotentizeOperator potentizeOp = new PotentizeOperator(paStrOriginalSource, paIntLine, paIntCol);

      potentizeOp.strSource = "^";
      potentizeOp.iSrcLength = 1;

      return potentizeOp;
    }

    // if ("**".equals(paStr)) {
    // return potentizeOp;
    // }
    // else if (paStr.length()>2 &&  && paStr.charAt(2)!='*') {
    // return potentizeOp;
    // }

    return null; // throw new NoSuchTokenException(paIntLine, paIntCol, paStr, "no potentize operator");

  }// end method parse

  /**
   * constructor
   */
  public PotentizeOperator(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the operator
   */
  public Object eval(Object paObjLeft, Object paObjRight) throws ExpressionEvaluationException {

    if (paObjLeft == null) {
      throw new ExpressionEvaluationException(this, "left operand is null");
    }
    if (!(paObjLeft instanceof Number)) {
      throw new ExpressionEvaluationException(this,
          "left operand is " + paObjLeft + ":" + paObjLeft.getClass().getName() + " ; BigDecimal expected");
    }

    if (paObjRight == null) {
      throw new ExpressionEvaluationException(this, "right operand is null");
    }
    if (!(paObjRight instanceof Number)) {
      throw new ExpressionEvaluationException(this,
          "right operand is " + paObjRight + ":" + paObjRight.getClass().getName() + " ; BigDecimal expected");
    }
    String strLeftValue = "" + paObjLeft;
    String strRightValue = "" + paObjRight;

    return new BigDecimal(Math.pow(Double.parseDouble(strLeftValue), Double.parseDouble(strRightValue)));
  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public int[] getCheckReturnTypes(int[] paIntArrLeft, int[] paIntArrRight)  throws ExpressionParseException {
    return checkNumNumNum(this, paIntArrLeft, paIntArrRight);
  }// end method getCheckReturnTypes

  public int getPriorityLevel() {
    return 4;
  }// end method getPriorityLevel
}// end class
