package de.cnc.expression.util;


import java.util.ArrayList;

import de.cnc.expression.infixoperators.AbstractInfixOperator;


/**
 * auf AbstractInfixOperator typisierte ArrayList . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class AbstractInfixOperatorArrayList {

  /**
   * eigentliche ArrayList
   */
  private ArrayList clArrayList = new ArrayList();

  /**
   * typisiertes get
   */
  public AbstractInfixOperator get(int iPaIndex) {
    if (iPaIndex < 0 || iPaIndex >= clArrayList.size())
    {
//System.out.println( "index " + iPaIndex + " out of bounds " + ( clArrayList.size() - 1 ) );
        return null;
    }
    return (AbstractInfixOperator) clArrayList.get(iPaIndex);
  }// end method get

  /**
   * typisiertes letztes Element
   */
  public AbstractInfixOperator tail() {
    return (AbstractInfixOperator) clArrayList.get(clArrayList.size() - 1);
  }// end method tail

  /**
   * typisiertes add
   */
  public boolean add(AbstractInfixOperator strPaValue) {
    return clArrayList.add(strPaValue);
  }// end method add

  /**
   * size
   */
  public int size() {
    return clArrayList.size();
  }// end method size

  /**
   * Debug-Ausgabe
   */
  public String toString() {
    return "" + clArrayList;
  }// end method toString

} // end class AbstractInfixOperatorArrayList
