package de.cnc.expression.util;

import java.util.ArrayList;

import de.cnc.expression.Expression;

/**
 * auf Expression typisierte ArrayList . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public class ExpressionArrayList
{

    /**
     * eigentliche ArrayList
     */
    private ArrayList exprArrList = new ArrayList();

    /**
     * typisiertes get
     */
    public Expression get(int iPaIndex)
    {
        return (Expression) exprArrList.get(iPaIndex);
    } // end method get

    /**
     * typisiertes letztes Element
     */
    public Expression tail()
    {
        return (Expression) exprArrList.get(exprArrList.size() - 1);
    } // end method tail

    /**
     * typisiertes add
     */
    public boolean add(Expression strPaValue)
    {
        return exprArrList.add(strPaValue);
    } // end method add

    /**
     * size
     */
    public int size()
    {
        return exprArrList.size();
    } // end method size

    /**
     * @return empty ja oder nein
     */
    public boolean isEmpty()
    {
        return exprArrList.isEmpty();
    }

    /**
     * Debug-Ausgabe
     */
    public String toString()
    {
        return "" + exprArrList;
    }

    /**
     * Operator-Prioritt organisieren (klammern)
     */
    public void organizeOperatorPriority()
    {
        for (int i = 0; i < exprArrList.size(); i++)
        {
            Expression expr = (Expression) exprArrList.get( i );
            expr.organizeOperatorPriority();
        }
    }

} // end class ExpressionArrayList
