package de.cnc.expression.util;


import java.io.PrintStream;


/**
 * Statischer Halter fr den PrintStream von {@link PrintFunction}
 * und {@link PrintlnFunction} . <br>
 * Wird im CnC Expression Parser Online Tester auf einen MessageWriter umgebogen.
 */
public class OutPrintStream {

  // public static PrintStream out = System.out;

  private static ThreadLocal outThreadLocal = new ThreadLocal();

  public static void setOut(PrintStream out) {
    outThreadLocal.set(out);
  }

  public static PrintStream getOut() {

    PrintStream retOut = (PrintStream) outThreadLocal.get();

    if (retOut == null) {
      // kein PrintStream fr diesen Thread gesetzt
      retOut = System.out;
    }
    return retOut;
  }

}
