package de.cnc.expression.util;


/**
 * Stellt Hilfsmethoden zum Parsen zur Verfgung
 *
 * @author Heiner Kcker
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 */
public class ParserUtil
{

    /**
     * Anzahl weisse Zeichen am String-Anfang ermitteln.
     *
     * @param  paStr zu parsender String
     * @return Anzahl weisser Zeichen
     */
    public static int parseWhitesAndComments(String pStr)
    {
//System.out.println("parseWhitesAndComments|" + pStr + "|");
        int iRet = 0;

        while (iRet < pStr.length()) 
        {
            char cTmp = pStr.charAt(iRet);

            if (cTmp == ' '   // Space
                    || cTmp == '\t'  // Tabulator
                    || cTmp == '\n'  // NewLine
                    || cTmp == '\r') 
            {
                iRet++;
            }
            else if (iRet < pStr.length() && pStr.substring(iRet).startsWith("//"))
            {
                iRet += 2;
                for (; iRet < pStr.length(); iRet++)
                {
                    cTmp = pStr.charAt(iRet);

                    if (cTmp == '\n')
                    {
                        iRet++;
                        break;
                    }
   
                }
            }     
            else if (iRet < pStr.length() && pStr.substring(iRet).startsWith("/*"))
            {
                iRet += 2;
                for (; iRet < pStr.length(); iRet++)
                {
                    if (pStr.substring(iRet).startsWith("*/"))
                    {
                        iRet += 2;
                        break;
                    }
   
                }
            }     
            else
            {
                break;
            }
        }

        return iRet;
    }// end method parseWhites

    /**
     * Lnge eines eventuellen Bezeichners ermitteln.
     *
     * @param  paStr zu parsender String
     * @return Lnge des Bezeichners oder 0, wenn kein Bezeichner
     */
    public static int parseIdentifier(String pStr)
    {
        // erste Stelle ein Buchstabe
        // danach Buchstabe oder Ziffer

        // Prfung auf Buchstabe am Anfang
        //if (!Character.isLetter(paStr.charAt(0)))
        if (!Character.isJavaIdentifierStart(pStr.charAt(0)))
        {
           return 0;
        }
        int iRun = 1;
        for (; iRun < pStr.length(); iRun++)
        {
           char cTmp = pStr.charAt(iRun);

           //if (!(Character.isLetterOrDigit(cTmp)))
           if (!(Character.isJavaIdentifierPart(cTmp)))
           {
              // Ende des Variablen-Namens erreicht
              return iRun;
           }
        }
        return iRun;
    }
}
