package de.cnc.flowcompiler;


import java.util.ArrayList;

import de.cnc.FlowControlUtil;
import de.cnc.domainparser.util.SourcePosition;


/**
 * Liste mit Namen von Prozeduren und Labels zur Kontrolle auf doppelte Verwendung eines Namens . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class NameList extends ArrayList {

  /**
   * Hinzufgen eines neuen Symbol-Namens (<b>label</b> oder <b>procedure</b>) mit Prfung, ob schon vorhanden
   *
   * @param strPaName hinzuzufgender Symbol-Name
   * @throws RuntimeException ber {@link FlowControlCompiler#complain} wenn Symbol-Name schon vorhanden
   */
  public void add(String strPaName,
                  SourcePosition pSourcePosition)
  {
    for (int i = 0; i < size(); i++) {
      if (strPaName.equals(get(i))) {
        FlowControlUtil.complain("name " + strPaName + " already defined" , pSourcePosition);
      }// end if
    }// end for
    super.add((Object) strPaName);
  }// end method add(String)

}// end class NameList
