package de.cnc.implicit;

import javax.servlet.http.*;

import de.cnc.CncContext;
import de.cnc.util.BrowseControl;

/**
 * Implizite Actions zum Bl&auml;ttern . <br/>
 *
 * </pre>
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner K&uuml;cker</a><br/>
 * <br/>
 *
 * @author Heiner K&uuml;cker
 * @version $Id:$
 */
public class Browse
{ // implements ImplicitActionInterface {

    /**
     * Methode zum Positionieren auf Tabellenanfang in einer Bl&auml;tter-Tabelle . <br/>
     *
     * @param iPaIndex Index-Nummer (Basis 0) eines indizierten Buttons oder Links
     * @param request  HttpServletRequest  des zentralen Servlets f&uuml;r Zugriff auf Session und so weiter
     * @param response HttpServletResponse des zentralen Servlets
     *
     * @return String-R&uuml;ckgabewert f&uuml;r eventuelle Auswertung
     */
    public static Object GoFirst(//-
    final int iPaIndex, //--
    final HttpServletRequest request, //--
    final HttpServletResponse response, // --
    final CncContext cncContext)
    {
        HttpSession session = request.getSession(true);

        BrowseControl.staticGoFirst(session);
        return null;
    } // end method

    /**
     * Methode zum Positionieren auf Tabellenende in einer Bl&auml;tter-Tabelle . <br/>
     *
     * @param iPaIndex Index-Nummer (Basis 0) eines indizierten Buttons oder Links
     * @param request  HttpServletRequest  des zentralen Servlets f&uuml;r Zugriff auf Session und so weiter
     * @param response HttpServletResponse des zentralen Servlets
     *
     * @return String-R&uuml;ckgabewert f&uuml;r eventuelle Auswertung
     */
    public static Object GoLast(//-
    final int iPaIndex, //--
    final HttpServletRequest request, //--
    final HttpServletResponse response, // --
    final CncContext cncContext)
    {
        HttpSession session = request.getSession(true);

        BrowseControl.staticGoLast(session);
        return null;
    } // end method

    /**
     * Methode zum Positionieren vorige Seite in einer Bl&auml;tter-Tabelle . <br/>
     *
     * @param iPaIndex Index-Nummer (Basis 0) eines indizierten Buttons oder Links
     * @param request  HttpServletRequest  des zentralen Servlets f&uuml;r Zugriff auf Session und so weiter
     * @param response HttpServletResponse des zentralen Servlets
     *
     * @return String-R&uuml;ckgabewert f&uuml;r eventuelle Auswertung
     */
    public static Object GoPrev(//-
    final int iPaIndex, //--
    final HttpServletRequest request, //--
    final HttpServletResponse response, // --
    final CncContext cncContext)
    {
        HttpSession session = request.getSession(true);

        BrowseControl.staticGoPrev(session);
        return null;
    } // end method

    /**
     * Methode zum Positionieren auf n&auml;chste Seite in einer Bl&auml;tter-Tabelle . <br/>
     *
     * @param iPaIndex Index-Nummer (Basis 0) eines indizierten Buttons oder Links
     * @param request  HttpServletRequest  des zentralen Servlets f&uuml;r Zugriff auf Session und so weiter
     * @param response HttpServletResponse des zentralen Servlets
     *
     * @return String-R&uuml;ckgabewert f&uuml;r eventuelle Auswertung
     */
    public static Object GoNext(//-
    final int iPaIndex, //--
    final HttpServletRequest request, //--
    final HttpServletResponse response, // --
    final CncContext cncContext)
    {
        HttpSession session = request.getSession(true);

        BrowseControl.staticGoNext(session);
        return null;
    } // end method

    /**
     * Methode zum Positionieren auf die vorige Position in einer Bl&auml;tter-Tabelle . <br/>
     *
     * @param iPaIndex Index-Nummer (Basis 0) eines indizierten Buttons oder Links
     * @param request  HttpServletRequest  des zentralen Servlets f&uuml;r Zugriff auf Session und so weiter
     * @param response HttpServletResponse des zentralen Servlets
     *
     * @return String-R&uuml;ckgabewert f&uuml;r eventuelle Auswertung
     */
    public static Object GoPrevPos(//-
    final int iPaIndex, //--
    final HttpServletRequest request, //--
    final HttpServletResponse response, // --
    final CncContext cncContext)
    {
        HttpSession session = request.getSession();

        BrowseControl.staticGoPrevPos(session);
        return null;
    } // end method

    /**
     * Methode zum Positionieren auf die n&auml;chste Position in einer Bl&auml;tter-Tabelle . <br/>
     *
     * @param iPaIndex Index-Nummer (Basis 0) eines indizierten Buttons oder Links
     * @param request  HttpServletRequest  des zentralen Servlets f&uuml;r Zugriff auf Session und so weiter
     * @param response HttpServletResponse des zentralen Servlets
     *
     * @return String-R&uuml;ckgabewert f&uuml;r eventuelle Auswertung
     */
    public static Object GoNextPos(//-
    final int iPaIndex, //--
    final HttpServletRequest request, //--
    final HttpServletResponse response, // --
    final CncContext cncContext)
    {
        HttpSession session = request.getSession();

        BrowseControl.staticGoNextPos(session);
        return null;
    } // end method

} // end class Browse
