package de.cnc.implicit;

import javax.servlet.http.*;

import de.cnc.*;
import de.cnc.CncContext;
import de.cnc.treecontrol.TreeNode;
import de.cnc.util.*;
import de.cnc.util.BrowseControl;

/**
 * Implizite Actions fr das Tree-Control . <br/>
 *
 * </pre>
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner K&uuml;cker</a><br/>
 * <br/>
 *
 * @author Heiner K&uuml;cker
 * @version $Id:$
 */
public class TreeActions
{ // implements ImplicitActionInterface {

    /**
     * Methode zum Ausklappen . <br/>
     *
     * @param iPaIndex Index-Nummer (Basis 0) eines indizierten Buttons oder Links
     * @param request  HttpServletRequest  des zentralen Servlets f&uuml;r Zugriff auf Session und so weiter
     * @param response HttpServletResponse des zentralen Servlets
     *
     * @return String-R&uuml;ckgabewert f&uuml;r eventuelle Auswertung
     */
    public static Object expand(//-
    final int iPaIndex, //--
    final HttpServletRequest request, //--
    final HttpServletResponse response, // --
    final CncContext cncContext)
    {
        HttpSession session = request.getSession();

        final TreeNode root = (TreeNode) session.getAttribute(SessionKeys.CNC_TREE_KEY);

        final String pathStr = request.getParameter("elemPath"); //@todo: Konstante

        final TreeNode node = getSubNode(root, pathStr);

        node.isExpanded = true;

        return null;
    }

    /**
     * Methode zum Einklappen . <br/>
     *
     * @param iPaIndex Index-Nummer (Basis 0) eines indizierten Buttons oder Links
     * @param request  HttpServletRequest  des zentralen Servlets f&uuml;r Zugriff auf Session und so weiter
     * @param response HttpServletResponse des zentralen Servlets
     *
     * @return String-R&uuml;ckgabewert f&uuml;r eventuelle Auswertung
     */
    public static Object collapse(//-
    final int iPaIndex, //--
    final HttpServletRequest request, //--
    final HttpServletResponse response, // --
    final CncContext cncContext)
    {
        HttpSession session = request.getSession();

        final TreeNode root = (TreeNode) session.getAttribute(SessionKeys.CNC_TREE_KEY);

        final String pathStr = request.getParameter("elemPath"); //@todo: Konstante

        final TreeNode node = getSubNode(root, pathStr);

        node.isExpanded = false;

        return null;
    }

    /**
     * vom bergebenen Path-String (Index-Nummern durch Underscore
     * separiert) adressierte Sub-Node zurckgeben.
     * 
     * @param pNode
     * @param pPathStr
     * @return
     */
    public static TreeNode getSubNode(//--
        final TreeNode pNode, //--
        final String pPathStr)
    {
        final int[] indexArr = parsePathStr(pPathStr);
        TreeNode subNode = pNode;
        for (int i = 0; i < indexArr.length; i++)
        {
            subNode = subNode.getNode(indexArr[i]);
        }
        return subNode;
    }

    /**
     * bergebenen Path-String in int-Werte zerlegen.
     * 
     * @param pPathStr
     * @return
     */
    private static int[] parsePathStr(String pPathStr)
    {
//System.out.println( "pPathStr: " + pPathStr );
        //final String[] pathStrArr = pPathStr.split("_");
        final String[] pathStrArr = StringUtil.tokenize( pPathStr, "_", false, false);
        final int[] pathIndexArr = new int[ pathStrArr.length ];
        for (int i = 0; i < pathIndexArr.length; i++)
        {
//System.out.println( "pathStrArr[" + i + "]: " + pathStrArr[i] );
            pathIndexArr[i] = Integer.parseInt(pathStrArr[i]);
        }
        return pathIndexArr;
    }

}
