package de.cnc.persistens;

import java.lang.reflect.Method;

/**
 * Diese Klasse enthlt die Definitionen und Methoden (fr Reflection)
 * eines Datenbank-Feldes.
 * 
 * @author Heiner Kcker
 * @since 09.09.2004
 */
public class DbFieldDefinitionAndMethods
{

   /**
    * Feldnamen
    */
   public String fieldName;

   /**
    * Feld-Typ (Boolean|Integer|Long|Double|BigDecimal|String|Date|Timestamp)
    */
   public String fieldTyp;

   /**
    * Property-Name
    */
   public String propertyName;

   /**
    * Get-Methode
    */
   public Method getMethod;

   /**
    * Set-Methode
    */
   public Method setMethod;

   /**
    * in diesem Feld den aktuellen TIMESTAMP beim INSERT setzen
    */
   public boolean currentTimeStampOnInsert;

   /**
    * in diesem Feld den aktuellen TIMESTAMP beim UPDATE setzen
    */
   public boolean currentTimeStampOnUpdate;

   /**
    * in diesem Feld den aktuellen User beim INSERT setzen
    */
   public boolean currentUserOnInsert;

   /**
    * in diesem Feld den aktuellen User beim UPDATE setzen
    */
   public boolean currentUserOnUpdate;

   /**
    * dieses Feld nur Lesen, niemals Schreiben
    */
   public boolean readOnly;

   /**
    * fr dieses Feld eine laufende Nummer als Key erzeugen
    */
   public boolean generateKey;

   /**
    * dieses Feld nur beim Insert beschreiben, niemals beim Update
    */
   public boolean noUpdate;

   /**
    * diesen Wert beim Insert setzen
    */
   public String insertValue;

   /**
    * diesen Wert beim Update setzen
    */
   public String updateValue;

   /**
    * nach Lesen von der DB trimmen
    */
   public boolean trimByRead;

   /**
    * ist Sekundr-Schlssel
    */
   public boolean isForeignKey;

}
