package de.cnc.persistens;

import de.cnc.util.StringUtil;

/**
 * Hilfsklasse fr {@link de.cnc.server.PersistensHelper} . <br/>
 * Datenstruktur fr den {@link de.cnc.server.PersistensHelper#databaseDefinitionAndMethodsCache} . <br/>
 * Enthlt das Mapping ActionFormBean {@link de.cnc.persistens} zwischen Datenbank-Tabelle und <br/>
 * Bean-Properties mit Datenbank-Feldern, <br/>
 * welches aus xxx.properties ermittelt wird. <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id $
 */
public final class DbTableDefinitionAndMethods
{
   /**
    * Name der Datenbank bei Betrieb mit mehreren Datenbanken
    */
   public String   dbName;

  /**
   * Name der Datenbanktabelle
   */
  public String   tableName;

  /**
   * Name des Feldes mit dem Primery-Key
   */
  public String   primaryKeyFieldName;

   /**
    * Felder mit Foreign-Keys
    */
   public String[] foreignKeyFieldNameArr;

   /**
    * Bean-Properties zu den Feldern mit Foreign-Keys
    */
   public String[] foreignKeyPropertyNameArr;

  /**
   * Maximale Treffer-Anzahl bei SELECT.
   * Wird realisiert ber "FETCH FIRST &gt;num&lt; ONLY".
   * 0 oder kleiner bedeutet keine Angabe.
   *
   * @return maximale Trefferanzahl
   */
   public int maxFetch;

   /**
    * selectasterisk wenn ja, dann "SELECT * ..." sonst mit Feld-Liste
    */
   public boolean selectAsterisk;
   
   /**
    * String mit der FeldListe fr SELECT.
    * Im Default-Fall einfach '*'.
    */
   public String selectFieldsStr;

   /**
    * String mit der FeldListe mit Tabellen-Prefix fr SELECT.
    * Im Default-Fall einfach '*'.
    */
   public String qualifiedSelectFieldsStr;

   /**
    * ob die Datenstze gecacht werden sollen
    */
   public boolean cacheUse = false;

   /**
    *
    */
   public String selectForUpdateSQLStatement;

  /**
   * Die einzelnen Felder
   */
  public DbFieldDefinitionAndMethods[] fieldArr;

  /**
   * Hinzufgen Feld . <br/>
   *
   * @param
   */
  public void addField(DbFieldDefinitionAndMethods pField)
  {
     fieldArr = (DbFieldDefinitionAndMethods[])
            StringUtil.arrAdd(fieldArr, pField);
  }

}

