package de.cnc.taglib;


import java.io.IOException;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.TagSupport;

import de.cnc.RequestKeys;


/**
 * Erzeugen eines Goto-Button-<b>&lt;input type=&quot;submit&quot; name=&quot;...&quot; value=&quot;...&quot;&gt;</b>-Tags . <br/><br/>
 * <pre>
 * Verwendung:
 * <b>&lt;cnc:buttongoto name="cnc_goto_..." value="..."/&gt;</b>
 * </pre>
 * siehe Datei <b>cnc.tld</b> . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id:$
 */
public class ButtonGotoTag extends TagSupport {

  /**
   * Dieser String wird nach Button-Prefix im name="..."-Parameter
   * des Button-Tags eingebaut und kann spter in flow.cnc mit &lt;if button="name">
   * abgefragt werden.
   */
  private String name = "";

  /**
   * Dieser Text wird als value= in das erzeugte Tag eingefgt und ist der Text auf dem Button
   */
  private String value = "";

  /**
   * get name
   *
   * @return name
   */
  public String getName() {
    return name;
  }// end method getName

  /**
   * set name
   *
   * @param name new Value
   */
  public void setName(String newName) {
    this.name = newName;
  }// end method setName

  /**
   * get value
   *
   * @return value
   */
  public String getValue() {
    return value;
  }// end method getValue

  /**
   * set value
   *
   * @param value new Value
   */
  public void setValue(String newValue) {
    this.value = newValue;
  }// end method setValue

  /**
   * Erzeugung HTML-Code
   *
   * @return Code fr Weiterbearbeiten Seite oder Abbruch
   *
   * @exception JspException if a JSP exception has occurred
   */
  public int doStartTag()
      throws JspException {

    //HttpSession session = pageContext.getSession();

    // <input type="submit" name="cnc_goto_begin" value="Haupt-Men"/>

    // fester Prefix cnc_goto_
    // noch Konstante fr cnc_button_ machen
    String  outString = "<input type=\"submit\" value=\"" + value + "\" name=\"" + RequestKeys.CNC_GOTO_ACTION_PREFIX + name
        + "\">";

    JspWriter writer = pageContext.getOut();

    try {
      writer.print(outString);
    } catch (IOException e) {
      throw new JspException(e.toString());
    }

    return (EVAL_PAGE);
  } // end method doStartTag

  /**
   * nichts zu tun
   *
   * @return Code fr Weiterverarbeitung JSP
   *
   * @throws JspException
   */
  public int doEndTag()
      throws JspException {
    return (EVAL_PAGE);
  }// end method doStartTag

}// end class ButtonGotoTag
