package de.cnc.taglib;


import java.io.IOException;

import javax.servlet.http.HttpSession;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.TagSupport;

import de.cnc.RequestKeys;
import de.cnc.util.BrowseControl;


/**
 * Erzeugen eines Goto-Button-<b>&lt;input type=&quot;submit&quot; name=&quot;...&quot; value=&quot;...&quot;&gt;</b>-Tags . <br/><br/>
 * <pre>
 * Verwendung:
 * <b>&lt;cnc:buttongoto name="cnc_goto_..." value="..."/&gt;</b>
 * </pre>
 * siehe Datei <b>cnc.tld</b> . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id:$
 */
public class ButtonPrevPageTag extends TagSupport {

  /**
   * Dieser String wird nach Button-Prefix im name="..."-Parameter
   * des Button-Tags eingebaut und kann spter in flow.cnc mit &lt;if button="name">
   * abgefragt werden.
   */
  private String name = "";

  /**
   * Dieser Text wird als value= in das erzeugte Tag eingefgt und ist der Text auf dem Button
   */
  // private String value = "Vorige Seite" ;
  private String value = "<<";

  /**
   * get name
   *
   * @return name
   */
  public String getName() {
    return name;
  }// end method getName

  /**
   * set name
   *
   * @param name new Value
   */
  public void setName(String newName) {
    this.name = newName;
  }// end method setName

  /**
   * get value
   *
   * @return value
   */
  public String getValue() {
    return value;
  }// end method getValue

  /**
   * set value
   *
   * @param value new Value
   */
  public void setValue(String newValue) {
    this.value = newValue;
  }// end method setValue

  /**
   * Erzeugung HTML-Code
   *
   * @return Code fr Weiterbearbeiten Seite oder Abbruch
   *
   * @exception JspException if a JSP exception has occurred
   */
  public int doStartTag()
      throws JspException {

    HttpSession session = pageContext.getSession();

    String outString = "&nbsp;&nbsp;&nbsp;";

    if (!BrowseControl.staticIsFirstPage(session)) {
      //outString = "<input type=\"submit\" value=\"" + value + "\" name=\"" + RequestKeys.CNC_PREV_PAGE_ACTION + "\">";
      outString = "<input type=\"submit\" value=\"" + value + "\" name=\"" + RequestKeys.CNC_IMPL_ACTION_PREFIX + "Browse#GoPrev" + "\">";
    }// end if

    JspWriter writer = pageContext.getOut();

    try {
      writer.print(outString);
    } catch (IOException e) {
      throw new JspException(e.toString());
    }

    return (EVAL_PAGE);
  } // end method doStartTag

  /**
   * nichts zu tun
   *
   * @return Code fr Weiterverarbeitung JSP
   *
   * @throws JspException
   */
  public int doEndTag()
      throws JspException {
    return (EVAL_PAGE);
  }// end method doStartTag

}// end class ButtonPrevPageTag
