package de.cnc.taglib;


import java.io.IOException;
import java.util.*;

import javax.servlet.http.HttpSession;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.TagSupport;

import de.cnc.RequestKeys;


/**
 * Fr das Einzelschritt-Debug muss der jeweilige Request
 * zwischengespeichert und in /cncdebug/singlestepdebug.jsp
 * mit Hidden-Fields wieder hergestellt werden . <br/>
 *
 * Der vorherige Requests ist auf dem festen Session-Key
 * CNC_SINGLE_STEP_DEBUG_REQUEST gespeichert . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class DebugRequestFieldsTag extends TagSupport {

  /**
   * Erzeugung HTML-Code
   *
   * @return Code fr Weiterbearbeiten Seite oder Abbruch
   *
   * @exception JspException if a JSP exception has occurred
   */
  public int doStartTag()
      throws JspException {

    HttpSession session = pageContext.getSession();

    // noch Fehlerabfangung einbauen

    // die vorherigen Request-Parameter werden als Hidden-Fields
    // in die Form der JSP-Seite eingefgt
    StringBuffer sb = new StringBuffer(1024 * 4);
    HashMap reqHashMap = (HashMap) session.getAttribute("CNC_SINGLE_STEP_DEBUG_REQUEST");

    if (reqHashMap != null) {
      sb.append("<!-- start cnc:debugrqfields -->\n");
      Iterator reqIterator = reqHashMap.entrySet().iterator();

      while (reqIterator.hasNext()) {
        Map.Entry entry = (Map.Entry) reqIterator.next();

        // Log.debug( "Eintrag:" + (String) entry.getKey() + "->" + (String) entry.getValue() ) ;
        if (!"cnc_status".equals((String) entry.getKey())     // Achtung, cnc_status nicht berschreiben
            && !((String) entry.getKey()).startsWith(RequestKeys.CNC_GOTO_ACTION_PREFIX)) { // Achtung, cnc_goto_-Information nicht weitergeben, weil sonst immer wieder das gleiche Label angesprungen wird
          sb.append("<input type=\"hidden\" name=\"" + (String) entry.getKey() + "\" value=\"" + (String) entry.getValue()
              + "\"/>\n");
        }// end if
      }// end while
      sb.append("<!-- end cnc:debugrqfields -->\n");
    }// end if

    String outStr = sb.toString();
    JspWriter writer = pageContext.getOut();

    try {
      writer.print(outStr);
    } catch (IOException e) {
      throw new JspException(e.toString());
    }

    return (EVAL_PAGE);
  }// end method doStartTag

  /**
   * nichts zu tun
   *
   * @return Code fr Weiterverarbeitung JSP
   *
   * @throws JspException
   */
  public int doEndTag()
      throws JspException {
    return (EVAL_PAGE);
  }// end method doStartTag

}// end class DebugRequestFieldsTag
