package de.cnc.taglib;

import java.io.IOException;
import java.util.*;

import javax.servlet.http.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.TagSupport;

import de.cnc.*;
import de.cnc.util.*;

/**
 * Debug-Ausgabe flow.cnc . <br/>
 * <br/>
 * Gibt<br/>
 * &nbsp;die Session,<br/>
 * &nbsp;den FlowStack,<br/>
 * &nbsp;die aktuelle procedure mit Hervorhebung aktuelle Programmzeile (wenn nicht main),<br/>
 * &nbsp;flow.cnc gesamt mit Hervorhebung aktuelle Programmzeile,<br/>
 * &nbsp;und bei Single-Step-Debug den gltigen HttpRequest und die gltige Action<br/>
 * aus.<br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id:$
 */
public class DebugTag extends TagSupport
{

    /**
     * property entireFlow
     */
    private String entireFlow;

    /**
     * ob immer anzeigen oder nur wenn
     * Log.isDebug() true liefert
     */
    private String ever;

    /**
     * get entireFlow
     *
     * @return entireFlow
     */
    //  public String getEntireFlow() {
    //    return entireFlow;
    //  }// end method getEntireFlow

    /**
     * set entireFlow
     *
     * @param newEntireFlow entireFlow new Value
     */
    public void setEntireFlow(String newEntireFlow)
    {
        this.entireFlow = newEntireFlow;
    } // end method setEntireFlow

    /**
     * @param pString
     */
    public void setEver(String pString)
    {
        ever = pString;
    }

    /**
     * Erzeugung HTML-Code
     *
     * @return Code fr Weiterbearbeiten Seite oder Abbruch
     *
     * @exception JspException if a JSP exception has occurred
     */
    public int doStartTag() throws JspException
    {
//try {
        Log.debug(this.getClass().getName() ,"doStartTag()");

        //    if ( ! Log.isDebug() && ! StringUtil.str2bool( ever ) )
        //    {
        //       //Schalter DEBUG ist off und keine Anzeige unbedingt eingeschaltet
        //       return (EVAL_PAGE);
        //    }

        HttpServletRequest request =
            (HttpServletRequest) pageContext.getRequest();
        HttpSession session = pageContext.getSession();

        // noch Fehlerabfangung einbauen
        // String outStr = FlowControl.getHtmlDebug( session ) ;
        StringBuffer outStrBuff = new StringBuffer("<hr>");

        outStrBuff.append(Log.htmlDump(request));

        outStrBuff.append(Log.htmlDump(session));

        if (session.getAttribute(SessionKeys.CNC_SINGLE_STEP_DEBUG) != null)
        {
            // Single-Step-Debug
            // Ausgabe gltige Request-Parameter
            final HashMap reqHashMap =
                (HashMap) session.getAttribute("CNC_SINGLE_STEP_DEBUG_REQUEST");

            if (reqHashMap != null)
            {
                outStrBuff.append(" <pre>");

                // outStrBuff.append( "actually HttpRequest\n" ) ;
                // outStrBuff.append( "--------------------\n" ) ;
                outStrBuff.append("<u>actually HttpRequest</u>\n\n");

                // outStrBuff.append( " \n" ) ;
                Iterator reqIterator = reqHashMap.entrySet().iterator();

                while (reqIterator.hasNext())
                {
                    Map.Entry entry = (Map.Entry) reqIterator.next();

                    outStrBuff.append(
                        "" + entry.getKey() + " -> " + entry.getValue() + "\n");
                } // end while
                outStrBuff.append("</pre>");
            } // end if
        } // end if

        // Button zum Einschalten Single-Step-Debug
        outStrBuff.append(
            "<p><form action=\"impl_action.cnc\" method=\"post\">");

        // bergabe CnC-Status in einem Hidden-Field
        outStrBuff.append(
            "<input type=\"hidden\" name=\""
                + RequestKeys.CNC_STATUS
                + "\" value=\""
                + session.getAttribute(SessionKeys.CNC_STATUS)
                + "\"/>");

        // bergabe RequestURI (aktueller JSP-Name) im Hidden-Field srcjsp
        String srcJsp = CncUtil.getCurrentJspName(request);
        outStrBuff.append(
            "<input type=\"hidden\" name=\""
                + RequestKeys.CNC_SRC_JSP
                + "\" value=\""
                + srcJsp
                + "\"/>");

        if (session.getAttribute(SessionKeys.CNC_SINGLE_STEP_DEBUG) == null)
        {
            //Button zum Einschalten Single-Step-DEBUG anbieten, falls DEBUG off
            outStrBuff.append(
                "<input type=\"submit\" name=\""
                    + RequestKeys.CNC_IMPL_ACTION_PREFIX
                    + "Debug#debugOn\" value=\"Single Step Debug ON\"/>\n");
        }
        else
        {
            //Button zum Ausschalten Single-Step-DEBUG anbieten, falls DEBUG on
            outStrBuff.append(
                "<input type=\"submit\" name=\"cnc_debug_off\" value=\"Single-Step-Debug off\"/>\n");
        }

        outStrBuff.append("</form></p>\n");
        // end Button zum Einschalten Single-Step-Debug

        // outStrBuff.append( FlowControl.getHtmlDebug( request ) ) ;
        if (StringUtil.str2bool(entireFlow))
        {
            // das gesamte Fluss-Script ausgeben
            outStrBuff.append(FlowControl.getHtmlDebugWithEntireFlow(request));
        }
        else
        {
            //nur die aktuelle procedure / function ausgeben
            outStrBuff.append(
                FlowControl.getHtmlDebugWithoutEntireFlow(request));
        }

        String outStr = outStrBuff.toString();
        JspWriter writer = pageContext.getOut();

        try
        {
            writer.print(outStr);
        }
        catch (IOException e)
        {
            Log.fatal(e);
            throw new JspException(e.toString());
        }
//} catch (Exception e)
//{
//    Log.fatal(e);
//}

        return (EVAL_PAGE);
    } // end method doStartTag

    /**
     * nichts zu tun
     *
     * @return Code fr Weiterverarbeitung JSP
     *
     * @throws JspException
     */
    public int doEndTag() throws JspException
    {
        Log.debug(this.getClass().getName() ,"doEndTag()");
        return (EVAL_PAGE);
    } // end method doStartTag

} // end class DebugTag
