package de.cnc.taglib;


import java.io.IOException;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.TagSupport;

import de.cnc.RequestKeys;


/**
 * Erzeugen Abbruch-Button fr HTML-Forms mit Unterdrcken Einparsen Formular-Daten . <br/>
 * Verwendung: <b>&lt;cnc:formbreakbutton/&gt;</b><br/><br/>
 * siehe Datei <b>cnc.tld</b> . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id:  $
 */
public class FormBreakButtonTag extends TagSupport {

  /**
   * Dieser Text wird als value= in das erzeugte Tag eingefgt und ist der Text auf dem Button
   */
  private String value = "Abbruch";

  /**
   * get value
   *
   * @return value
   */
  public String getValue() {
    return value;
  }// end method getValue

  /**
   * set value
   *
   * @param value new Value
   */
  public void setValue(String newValue) {
    this.value = newValue;
  }// end method setValue

  /**
   * Defer our checking until the end of this tag is encountered.
   *
   * @exception JspException if a JSP exception has occurred
   */
  public int doStartTag()
      throws JspException {
    return (EVAL_PAGE);
  } // end method doStartTag

  /**
   * Ausgabe HTML-Text . <br/>
   *
   * @return Code fr Weiterverarbeitung JSP
   */
  public int doEndTag()
      throws JspException {
    // String outString = "<input type=\"submit\" name=\"" + RequestKeys.CNC_NO_PARSE + "\" value=\"" + value + "\"/>" ;
    String outString = "<input type=\"submit\" name=\"" + RequestKeys.CNC_BUTTON_NO_PARSE + "\" value=\"" + value + "\"/>";

    JspWriter writer = pageContext.getOut();

    try {
      writer.print(outString);
    } catch (IOException e) {
      throw new JspException(e.toString());
    }
    return EVAL_PAGE;
  }// end method doEndTag

}// end class FormBreakButtonTag
