package de.cnc.taglib;


import javax.servlet.jsp.JspException;


/**
 * IF-Not-Form-Field-Invalid-Tag . <br/>
 * Abarbeitung Tag-Body-Content abhngig von einem boolean-Property einer Session-Bean.<br/><br/>
 *
 * <pre>
 * Verwendung:
 * <b>&lt;cnc:ifnot  name=&quot;SessionKey&quot; property=&quot;boolean-Property&quot;&gt;</b>
 *  ... Tag-Body-Content
 * <b>&lt;/cnc:ifnot&gt;</b>
 * </pre>
 * siehe Datei <b>cnc.tld</b> . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class IfNotFieldInvalidTag extends IfFieldInvalidTag {

  /**
   * Entscheidung, ob Body abgearbeitet werden soll
   *
   * @return Code, ob Body abgearbeitet werden soll
   *
   * @throws JspException
   */
  public int doStartTag()
      throws JspException {
    // Log.debug( "doStartTag " + getClass().getName() ) ;

    // Aufruf Original-Methode
    final int retInt = super.doStartTag();
    // Negieren Rckgabe-Wert
    if (retInt == SKIP_BODY) 
    {
        return EVAL_PAGE;
    } 
    else 
    {
        return SKIP_BODY;
    }// end if
  }// end method doStartTag

}// end class IfNotTag
