package de.cnc.taglib;


import java.io.IOException;

import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.TagSupport;


/**
 * Tag zum Unterdrcken des Browser/Proxy-Cache, sollte am Beginn jedes JSP stehen. <body><br/><br/>
 * <pre>
 * Verwendung:
 *
 * &lt;cnc:nocache&gt;
 * </pre>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class NoCacheTag extends TagSupport {

  /**
   * Erzeugen HTML-Code
   *
   * @return Code fr JSP-Seite weiter abarbeiten
   *
   * @exception JspException if a JSP exception has occurred
   */
  public int doStartTag()
      throws JspException {
    HttpServletResponse response = (HttpServletResponse) pageContext.getResponse();

    response.setHeader("Expires", "Thu, 26 Dec 2000 00:00:00 GMT");
    response.setHeader("Cache-Control", "no-cache, must-revalidate");
    response.setHeader("Pragma", "no-cache");

    // Vorbereiten Ausgabe
    StringBuffer  outStrBuff = new StringBuffer(1024);

    outStrBuff.append("<meta http-equiv=\"expires\" content=\"Thu, 26 Dec 2000 00:00:00 GMT\">");
    outStrBuff.append("<meta http-equiv=\"pragma\" content=\"no-cache\">");

    JspWriter writer = pageContext.getOut();

    try {
      writer.print(outStrBuff.toString());
    } catch (IOException e) {
      throw new JspException(e.toString());
    }
    return (EVAL_PAGE);
  } // end method doStartTag

  /**
   * Tut nichts.<br/>
   *
   * @return Code fr Weiterverarbeitung JSP
   *
   * @throws JspException
   */
  public int doEndTag()
      throws JspException {
    return EVAL_PAGE;
  } // end method doEndTag

}// end class NoCacheTag
