package de.cnc.taglib;


import java.io.IOException;

import javax.servlet.http.HttpSession;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.TagSupport;

import de.cnc.SessionKeys;
import de.cnc.util.*;


/**
 * Ausgabe Text auf JSP-Seite . <br/>
 * Verwendung: <b>&lt;cnc:write/&gt;</b><br/><br/>
 * siehe Datei <b>cnc.tld</b> . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public class WriteTag extends TagSupport {

  /**
   * Session-Key, von dem das auszugebende Objekt zu holen ist.
   */
  private String sessionkey = SessionKeys.CNC_FORM_KEY;

  /**
   * anzuzeigendes Property der Bean auf dem angegeben SessionKey
   */
  protected String  property = "";

  /**
   * get sessionkey
   *
   * @return sessionkey
   */
  public String getSessionkey() {
    return sessionkey;
  }// end method getsessionkey

  /**
   * set sessionkey
   *
   * @param sessionkey new Value
   */
  public void setSessionkey(String newSessionkey) {
    this.sessionkey = newSessionkey;
  }// end method setSessionkey

  /**
   * get property
   *
   * @return property
   */
//  public String getProperty() {
//    return property;
//  }

  /**
   * set property
   *
   * @param property new Value
   */
  public void setProperty(String newProperty) {
    this.property = newProperty;
  }

  /**
   * Defer our checking until the end of this tag is encountered.
   *
   * @exception JspException if a JSP exception has occurred
   */
  public int doStartTag()
      throws JspException {
    return (EVAL_PAGE);
  } // end method doStartTag

  /**
   * Ausgabe Fehlertext . <br/>
   * Nach der Ausgabe wird der Fehlertext aus der Session gelscht.<br/>
   *
   * @return Code fr Weiterverarbeitung JSP
   */
  public int doEndTag()
      throws JspException {

    if (StringUtil.empty(sessionkey)) {
      throw new JspException("Property sessionkey in " + this.getClass().getName() + " expected");
    }// end if

    String      outString = "";
    HttpSession session = pageContext.getSession();
    Object      bean = session.getAttribute(sessionkey);

    if (bean != null) {
      if (StringUtil.empty(property)) {
        // Zugriff auf Objekt ingesamt
        outString = "" + bean;
      } else {
        // Zugriff auf Property
        Object propValue = BeanUtil.get(bean, property);

        if (propValue != null) {
          outString = propValue.toString();
        }// end if
      }// end if
    }// end if

    JspWriter writer = pageContext.getOut();

    try {
      writer.print(outString);
    } catch (IOException e) {
      throw new JspException(e.toString());
    }

    return EVAL_PAGE;
  }// end method doEndTag

}// end class WriteTag
