package de.cnc.treecontrol;

import java.util.ArrayList;

/**
 * Knoten fr das Tree-Control . <br/>
 * 
 * siehe Datei <b>cnc.tld</b> . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public class TreeNode
{
    /** Node Name */
    public String name;
    
    public boolean isExpanded;
    
    private ArrayList nodeList = new ArrayList();
    
    private TreeNode parent;

    /**
     * @return Returns the name.
     */
    public String getName()
    {
        return name;
    }
    /**
     * @param name The name to set.
     */
    public void setName(String name)
    {
        this.name = name;
    }
    public TreeNode(String newName)    
    {
        name = newName;
    }

    public void add( TreeNode pTreeNode)
    {
        pTreeNode.parent = this;
        nodeList.add( pTreeNode );
    }

    /**
     * @return Returns the nodeList.
     */
    public ArrayList getNodeList()
    {
        return nodeList;
    }
    public int nodeCount()    
    {
        return nodeList.size();
    }
    
    public TreeNode getNode(int pIndex)
    {
        return (TreeNode) nodeList.get(pIndex);
    }
    
    /**
     * @return
     */
    public TreeNode getParent()
    {
        return parent;
    }

    /**
     * @return
     */
    public TreeNode getRoot()
    {
        TreeNode root = this;
        while (root.parent != null)
        {
            root = root.parent;
        }
        return root;
    }

}
