package de.cnc.util;


import java.util.ArrayList;


/**
 * Methoden zum Verschieben (auf/ab) von Elementen in einer ArrayList . <br/>
 * Wird fr die Listeneditoren verwendet.<br/>
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class ArrayListUtil {

  /**
   * angesprochenes Element mit dem darberliegenden Element tauschen, wodurch das Element eine Position nach oben bewegt wird
   *
   * @param movePos
   */
  public static ArrayList moveUp(ArrayList arrList, int movePos) {
    if (movePos > 0 && movePos < arrList.size()) {
      Object  tmpObject = arrList.get(movePos);

      arrList.set(movePos, arrList.get(movePos - 1));
      arrList.set(movePos - 1, tmpObject);
    }
    return arrList;
  } // end method moveUp

  /**
   * angesprochenes Element mit dem darunterliegenden Element tauschen, wodurch das Element eine Position nach unten bewegt wird
   *
   * @param movePos
   */
  public static ArrayList moveDn(ArrayList arrList, int movePos) {
    if (movePos > -1 && movePos < arrList.size() - 1) {
      Object  tmpObject = arrList.get(movePos);

      arrList.set(movePos, arrList.get(movePos + 1));
      arrList.set(movePos + 1, tmpObject);
    }
    return arrList;
  } // end method moveDn

  /**
   * ArrayList aufw&auml;rts sortieren . <br/>
   * Die ArrayList-Elemente m&uuml;ssen das Interface <b>java.lang.Comparable<b/> implementieren.
   */
  public static ArrayList sortUp(ArrayList arrList) {
    for (int lauf = 0; lauf <= arrList.size(); lauf++) {
      for (int pos = 0; pos < arrList.size() - 1; pos++) {
        if (((Comparable) arrList.get(pos)).compareTo(arrList.get(pos + 1)) > 0) {
          Object puffer = arrList.get(pos);

          arrList.set(pos, arrList.get(pos + 1));
          arrList.set(pos + 1, puffer);
        }
      }
    }
    return arrList;
  } // end method sort

  /**
   * ArrayList ab&auml;rts sortieren . <br/>
   * Die ArrayList-Elemente m&uuml;ssen das Interface <b>java.lang.Comparable<b/> implementieren.
   */
  public static ArrayList sortDn(ArrayList arrList) {
    for (int lauf = 0; lauf <= arrList.size(); lauf++) {
      for (int pos = 0; pos < arrList.size() - 1; pos++) {
        if (((Comparable) arrList.get(pos)).compareTo(arrList.get(pos + 1)) < 0) {
          Object puffer = arrList.get(pos);

          arrList.set(pos, arrList.get(pos + 1));
          arrList.set(pos + 1, puffer);
        }
      }
    }
    return arrList;
  } // end method sort

} // end class ArrayListUtil
