package de.cnc.validator;

import java.util.*;

/**
 * Map-Klasse zum Halten der Fehlermeldungen fr invalide
 * HTML-Form-Felder . <br>
 * 
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public class FormFieldErrorMap
{
    private HashMap errMap = new HashMap();

    /**
     * @param arg0
     * @return
     */
    public Object put(FormFieldError pErr)
    {
        return errMap.put(pErr.getPropertyName(), pErr);
    }

    /**
     * 
     */
    public void clear()
    {
        errMap.clear();
    }

    /**
     * @param arg0
     * @return
     */
    public FormFieldError get(String pPropName)
    {
        return (FormFieldError) errMap.get(pPropName);
    }

    /**
     * @return
     */
    public boolean isEmpty()
    {
        return errMap.isEmpty();
    }

    /**
     * @return
     */
    public int size()
    {
        return errMap.size();
    }

    /**
     * @return
     */
    public Set entrySet()
    {
        return errMap.entrySet();
    }

    /**
     * @return
     */
    public Set keySet()
    {
        return errMap.keySet();
    }

    /**
     * Auf map mit [index] addieren, damit der Key in der Fehler-Map 
     * identisch ist mit dem Key im Request.
     * 
     * @param pIndex Listenposition Basis 0
     * @param pFormErrMap aufzuaddierende Map von der Bean, die ien Tabellenzeile reprsentiert
     */
    public void mapForIndex(//--
        int pIndex, //--
        FormFieldErrorMap pFormErrMap)
    {
        for (Iterator iter = pFormErrMap.keySet().iterator(); iter.hasNext();)
        {
            String keyStr = (String) iter.next();
//System.out.println( "keyStr: " + keyStr );
            FormFieldError runErr = pFormErrMap.get( keyStr );
//System.out.println( "runErr: " + runErr );
            
            errMap.put( keyStr + "[" + pIndex + "]" , runErr );
        }        
    }

    /**
     * Debug-Ausgabe
     */
    public String toString()
    {
        return this.getClass().getName() //--
        + "[errMap: " + errMap + "]";
    }
}
