package de.cncdemo.actions;


import java.util.ArrayList;

import javax.servlet.http.*;

import de.cnc.*;
import de.cnc.util.CncUtil;
import de.cncdemo.formbeans.*;
import de.cncdemo.formbeans.AktieFormBean;


/**
 * Action-Methoden fr die Frames-Demo 
 * in der CncDemo-Applikation. <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @see de.cnc.ActionMethodClassCache
 * @see CncServlet#getActionPackagePrefix
 * @author Heiner Kcker
 * @version $Id$
 */
public final class Frames {

  /**
   * load-Action . <br/>
   * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="..."&gt;</b> in <b>flow.cnc</b>.<br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
  public static String loadKunden( //--
      final int iPaIndex, //--
      final HttpServletRequest request, //--
      final HttpServletResponse response, // --
      final CncContext cncContext)
   {
    ArrayList arrList = new ArrayList();

    for (int i = 0; i < 10; i++) {
      KundeFormBean kunde = new KundeFormBean();

      kunde.setNachName("Kunde" + i);
      kunde.setVorName("Vorname" + i);
      kunde.setStrasseNr("Strasse " + i);
      kunde.setPlz("0000" + i);
      kunde.setOrt("Ort " + i);

      arrList.add(kunde);
    }// end for

    HttpSession session = request.getSession(true);

    session.setAttribute(SessionKeys.CNC_LIST_KEY, arrList);

    return null;
  }

  /**
   * load-Action . <br/>
   * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="..."&gt;</b> in <b>flow.cnc</b>.<br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
  public static String loadLieferanten( //--
      final int iPaIndex, //--
      final HttpServletRequest request, //--
      final HttpServletResponse response, // --
      final CncContext cncContext)
   {
    ArrayList arrList = new ArrayList();

    for (int i = 0; i < 10; i++) {
      LieferantFormBean lieferant = new LieferantFormBean();

      lieferant.setNachName("Lieferant" + i);
      lieferant.setVorName("Vorname" + i);
      lieferant.setStrasseNr("Strasse " + i);
      lieferant.setPlz("0000" + i);
      lieferant.setOrt("Ort " + i);

      arrList.add(lieferant);
    }// end for

    HttpSession session = request.getSession(true);

    session.setAttribute(SessionKeys.CNC_LIST_KEY, arrList);

    return null;
  }

  /**
   * save-Action . <br/>
   * Benutzt in <b>procdure liste_edit</b>.<br/>
   * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="..."&gt;</b> in <b>flow.cnc</b>.<br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
  public static String save( //--
      final int iPaIndex, //--
      final HttpServletRequest request, //--
      final HttpServletResponse response, // --
      final CncContext cncContext)
  {
    // Abspeichern in Datenbank nicht ausprogrammiert
    //HttpSession session = request.getSession(true);

    //session.removeAttribute(SessionKeys.CNC_LIST_KEY);
    
    CncUtil.setErrMessage(request, "Speichern in dieser Demoversion nicht mglich");
    return null;
  }// end method save

}
