package de.cncdemo.actions;


import java.util.ArrayList;

import javax.servlet.http.*;

import de.cnc.*;
import de.cnc.util.CncUtil;
import de.cncdemo.formbeans.AktieFormBean;


/**
 * Action-Methoden fr die JspSpreadsheet-Demo 
 * in der CncDemo-Applikation. <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @see de.cnc.ActionMethodClassCache
 * @see CncServlet#getActionPackagePrefix
 * @author Heiner Kcker
 * @version $Id$
 */
public final class JspSpreadsheet {

  // Actions fr Listen-Editor ***********************************************************************

  /**
   * load-Action . <br/>
   * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="..."&gt;</b> in <b>flow.cnc</b>.<br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
  public static String load( //--
  final int iPaIndex, //--
  final HttpServletRequest request, //--
  final HttpServletResponse response, // --
  final CncContext cncContext)
   {
    ArrayList arrList = new ArrayList();

    for (int i = 0; i < 4; i++) {
      AktieFormBean aktie = new AktieFormBean();

      aktie.setName("Aktie " + (i + 1));
      aktie.setPreis(i + 1);
      aktie.setAnzahl(i + 1);
      
      arrList.add(aktie);
    }// end for

    HttpSession session = request.getSession(true);

    session.setAttribute(SessionKeys.CNC_LIST_KEY, arrList);

    return null;
  }// end method load

  /**
   * add-Action . <br/>
   * Benutzt in <b>procdure liste_edit</b>.<br/>
   * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="..."&gt;</b> in <b>flow.cnc</b>.<br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
//  public static String add( //--
//  final int iPaIndex, //--
//  final HttpServletRequest request, //--
//  final HttpServletResponse response, // --
//  final CncContext cncContext)
//   {
//    ArrayList arrList = (ArrayList) (request.getSession(true)).getAttribute(SessionKeys.CNC_LIST_KEY);
//
//    AktieFormBean AktieFormBean = new AktieFormBean();
//
//    arrList.add(AktieFormBean);
//
//    return "";
//  }// end method add

  /**
   * ins-Action . <br/>
   * Benutzt in <b>procdure liste_edit</b>.<br/>
   * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="..."&gt;</b> in <b>flow.cnc</b>.<br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
//  public static String ins( //--
//  final int iPaIndex, //--
//  final HttpServletRequest request, //--
//  final HttpServletResponse response, // --
//  final CncContext cncContext)
//   {
//    ArrayList arrList = (ArrayList) (request.getSession(true)).getAttribute(SessionKeys.CNC_LIST_KEY);
//
//    AktieFormBean AktieFormBean = new AktieFormBean();
//
//    arrList.add(iPaIndex, AktieFormBean);
//    return "";
//  }// end method ins

  /**
   * del-Action . <br/>
   * Benutzt in <b>procdure liste_edit</b>.<br/>
   * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="..."&gt;</b> in <b>flow.cnc</b>.<br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
//  public static String del( //--
//  final int iPaIndex, //--
//  final HttpServletRequest request, //--
//  final HttpServletResponse response, // --
//  final CncContext cncContext)
//  {
//    ArrayList arrList = (ArrayList) (request.getSession(true)).getAttribute(SessionKeys.CNC_LIST_KEY);
//
//    arrList.remove(iPaIndex);
//    return "";
//  }// end method del

  /**
   * mvup-Action . <br/>
   * Benutzt in <b>procdure liste_edit</b>.<br/>
   * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="..."&gt;</b> in <b>flow.cnc</b>.<br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
//  public static String mvup( //--
//  final int iPaIndex, //--
//  final HttpServletRequest request, //--
//  final HttpServletResponse response, // --
//  final CncContext cncContext)
//   {
//    ArrayList arrList = (ArrayList) (request.getSession(true)).getAttribute(SessionKeys.CNC_LIST_KEY);
//
//    ArrayListUtil.moveUp(arrList, iPaIndex);
//    return "";
//  }// end method mvup

  /**
   * mvdn-Action . <br/>
   * Benutzt in <b>procdure liste_edit</b>.<br/>
   * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="..."&gt;</b> in <b>flow.cnc</b>.<br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
//  public static String mvdn( //--
//  final int iPaIndex, //--
//  final HttpServletRequest request, //--
//  final HttpServletResponse response, // --
//  final CncContext cncContext)
//  {
//    ArrayList arrList = (ArrayList) (request.getSession(true)).getAttribute(SessionKeys.CNC_LIST_KEY);
//
//    ArrayListUtil.moveDn(arrList, iPaIndex);
//    return "";
//  }// end method mvdn

  /**
   * save-Action . <br/>
   * Benutzt in <b>procdure liste_edit</b>.<br/>
   * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="..."&gt;</b> in <b>flow.cnc</b>.<br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
  public static String save( //--
      final int iPaIndex, //--
      final HttpServletRequest request, //--
      final HttpServletResponse response, // --
      final CncContext cncContext)
  {
    // Abspeichern in Datenbank nicht ausprogrammiert
    //HttpSession session = request.getSession(true);

    //session.removeAttribute(SessionKeys.CNC_LIST_KEY);
    
    CncUtil.setErrMessage(request, "Speichern in dieser Demoversion nicht mglich");
    return null;
  }// end method save

  /**
   * Ablegen einer Test-Liste zum Sortieren mit impliziten Actions auf den Sessionkey CNC_LIST_KEY
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
//  public static String getSortList( //--
//  final int iPaIndex, //--
//  final HttpServletRequest request, //--
//  final HttpServletResponse response, // --
//  final CncContext cncContext)
//   {
//    ArrayList arrList = new ArrayList();
//
//    for (int i = 0; i <= 9; i++) {
//      arrList.add(new Integer(i));
//    }
//
//    HttpSession session = request.getSession(true);
//
//    session.setAttribute(SessionKeys.CNC_LIST_KEY, arrList);
//    return "";
//  }// end method getSortList

}// end class JspSpreadsheet
