package de.cncdemo.formbeans;




/**
 * FormBean (Formular-Bean) fr eine Bestellungs-Position der Bestell-Demo-Applikation
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public final class BestellPositionFormBean {

  /**
   * Artikel dieser Bestell-Position
   */
  private ArtikelFormBean artikel;

  /**
   * Property Menge
   */
  private double posMenge;

  /**
   * get artikel
   *
   * @return artikel
   */
  public ArtikelFormBean getArtikel() {
    return artikel;
  }// end method getArtikel

  /**
   * set artikel
   *
   * @param newArtikel artikel new Value
   */
  public void setArtikel(ArtikelFormBean newArtikel) {
    if (newArtikel == null)
    {
        throw new NullPointerException();
    }
    this.artikel = newArtikel;
  }// end method setArtikel

  /**
   * get posMenge
   *
   * @return posMenge
   */
  public double getPosMenge() {
    return posMenge;
  }// end method getPosMenge

  /**
   * set posMenge
   *
   * @param posMenge new Value
   */
  public void setPosMenge(double newPosMenge) {
    this.posMenge = newPosMenge;
  }// end method setPosMenge

  /**
   * set posMenge
   *
   * @param posMenge new Value
   */

  /*
   public void setPosMenge( String newPosMenge ) {
   this.posMenge = StringUtil.str2double( newPosMenge ) ;
   }//end method setPosMenge
   */

  // *** delegierte Methoden ***

  /**
   * get artNr
   *
   * @return artNr
   */
  public String getArtNr() {
    return artikel.getArtNr();
  }// end method getArtNr

  /**
   * get bez
   *
   * @return bez
   */
  public String getBez() {
    return artikel.getBez();
  }// end method getBez

  /**
   * get me
   *
   * @return me
   */
  public String getMe() {
    return artikel.getMe();
  }// end method getMe

  public String toString() {
    return getClass().getName() + " " + "Artikel: " + artikel + " " + "posMenge: " + posMenge;
  }// end method toString

}// end class BestellPositionFormBean
