package de.cncdemo.formbeans;


import java.util.ArrayList;


/**
 * FormBean (Formular-Bean) fr eine Bestellung der Bestell-Demo-Applikation
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public final class BestellungFormBean implements Comparable
{

  /**
   * Nummer der Bestellung
   */
  private String nr;

  /**
   * Bezeichnung der Bestellung
   */
  private String bezeichnung;

  /**
   * ArrayList mit den Bestellungs-Positionen
   */
  private ArrayList positionen = new ArrayList();

  /**
   * get nr
   *
   * @return nr
   */
  public String getNr() {
    return nr;
  }// end method getNr

  /**
   * set nr
   *
   * @param newNr nr new Value
   */
  public void setNr(String newNr) {
    this.nr = newNr;
  }// end method setNr

  /**
   * get bezeichnung
   *
   * @return bezeichnung
   */
  public String getBezeichnung() {
    return bezeichnung;
  }// end method getBezeichnung

  /**
   * set bezeichnung
   *
   * @param newBezeichnung bezeichnung new Value
   */
  public void setBezeichnung(String newBezeichnung) {
    this.bezeichnung = newBezeichnung;
  }// end method setBezeichnung

  /**
   * get posCount
   *
   * @return posCount
   */
  public int getPosCount() {
    if (positionen == null) {
      return 0;
    }
    return positionen.size();
  }// end method getPosCount

  /**
   * get positionen
   *
   * @return positionen
   */
  public ArrayList getPositionen() {
    return positionen;
  }// end method getPositionen

  /**
   * set positionen
   *
   * @param newPositionen positionen new Value
   */
  public void setPositionen(ArrayList newPositionen) {
    this.positionen = newPositionen;
  }// end method setPositionen

  /**
   * @see java.lang.Comparable#compareTo(java.lang.Object)
   */
  public int compareTo(Object pObj)
  {
      BestellungFormBean otherBestellung = (BestellungFormBean) pObj;
      if (this.nr == null)
      {
          return -1;
      }
      return this.nr.compareTo( otherBestellung.nr );
  }

}// end class BestellungFormBean
