package de.cncdemo.formbeans;

import java.util.Date;

import javax.servlet.http.HttpServletRequest;

import de.cnc.FormValidatorInterface;
import de.cnc.util.CncUtil;
import de.cnc.validator.*;

/**
 * Bean zum Test der Form-Validierung . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public class DateValidatorFormBean implements FormValidatorInterface
{
    private Date date;

    /**
     * @return
     */
    public Date getDate()
    {
        return date;
    }

    /**
     * @param date
     */
    public void setDate(Date date)
    {
        this.date = date;
    }

    /** 
     * Prfen auf Validitt vor dem Einparsen des Browser-Request 
     * @return ob der Request valid ist
     */
//    public boolean isRequestValid(//--
//        final HttpServletRequest request)
//    {
//        return true;
//    }

    /** 
     * Prfen auf Validitt nach dem Einparsen des Browser-Request . <br>
     * 
     * Leider hat diese Methode einen Rckgabewert und einen Seiteneffekt
     * auf den {@link #pErrList}-Parameter. Das ist eigentlich nicht mein Stil,
     * aber in Java gibt es nicht die Mglichkeit mehrerer Rckgabewerte.
     * 
     * @return ob der Inhalt der Form-Bean valid ist
     */
    public boolean isBeanValid(//--
        final HttpServletRequest request, //--
        final FormFieldErrorMap pErrMap)
    {
        //wenn datum nicht null, dann valid
        if ( date != null )
        {
            return true;
        }
        CncUtil.setWarnMessage(request, "Das eingegebene Datum ist nicht korrekt!");
        pErrMap.put( new FormFieldError( "date" , "Das eingegebene Datum ist nicht korrekt!" ) );
        return false;
    }

}
