package de.cncdemo.formbeans;

import javax.servlet.http.HttpServletRequest;

import de.cnc.FormValidatorInterface;
import de.cnc.util.*;
import de.cnc.validator.*;


/**
 * ActionFormBean (Formular-Bean) fr den Test des Listen-Editors
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public final class ListeActionFormBean implements FormValidatorInterface
{

  /**
   * Property check fr Checkbox
   */
  private boolean check;

  /**
   * Property Textfeld
   */
  private String txt = "";

  /**
   * Property Textfeld
   */
  private Double doubleNumber = new Double(0);

  /**
   * property radio
   */
  private String radio = "a";

  /**
   * property select
   */
  private String select;

  /**
   * selectbox options for property select
   */
  private final String[] selectSelectboxOptions = { "select1", "select2", "select3", "select4", "select5" };

  /**
   * get check
   *
   * @return check
   */
  public boolean getCheck() {
    return check;
  }// end method getCheck

  /**
   * set check
   *
   * @param newCheck check new Value
   */
  public void setCheck(boolean newCheck) {
    this.check = newCheck;
  }// end method setCheck

  // public void setCheck( String newCheck ) {
  // this.check = de.cnc.util.StringUtil.str2bool( newCheck );
  // }//end method setCheck

  /**
   * get txt
   *
   * @return txt
   */
  public String getTxt() {
    return txt;
  }// end method getTxt

  /**
   * set txt
   *
   * @param txt new Value
   */
  public void setTxt(String newTxt) {
    this.txt = newTxt;
  }// end method setTxt

  /**
   * get doubleNumber
   *
   * @return doubleNumber
   */
  public Double getDoubleNumber() {
    return doubleNumber;
  }// end method getDoubleNumber

  /**
   * set doubleNumber
   *
   * @param newDoubleNumber doubleNumber new Value
   */
  public void setDoubleNumber(Double newDoubleNumber) {
    this.doubleNumber = newDoubleNumber;
  }// end method setDoubleNumber

  /**
   * get radio
   *
   * @return radio
   */
  public String getRadio() {
    return radio;
  }// end method getRadio

  /**
   * set radio
   *
   * @param newRadio radio new Value
   */
  public void setRadio(String newRadio) {
    this.radio = newRadio;
  }// end method setRadio

  /**
   * get select
   *
   * @return select
   */
  public String getSelect() {
    return select;
  }// end method getSelect

  /**
   * set select
   *
   * @param newSelect select new Value
   */
  public void setSelect(String newSelect) {
    this.select = newSelect;
  }// end method setSelect

  /**
   * get selectbox options for property select
   *
   * @return selectbox options for property select
   */
  public String[] getSelectSelectboxOptions() {
    return selectSelectboxOptions;
  }// end method getSelectSelectboxOptions

    /**
     * @see de.cnc.FormValidatorInterface#isBeanValid(javax.servlet.http.HttpServletRequest, de.cnc.validator.FormFieldErrorMap)
     */
    public boolean isBeanValid(
        HttpServletRequest request,
        FormFieldErrorMap pErrMap)
    {
        if ( ! StringUtil.empty( txt ) )
        {
            return true;
        }
        CncUtil.setWarnMessage(request, "Bitte Text eingeben!");
        pErrMap.put( new FormFieldError( "txt" , "Bitte Text eingeben!" ) );
        return false;
    }

}// end class ListeActionFormBean
