package de.cncdemo.implicit;

import java.util.ArrayList;

import javax.servlet.http.*;

import de.cnc.*;
import de.cnc.util.*;

/**
 * Implizite Action zum Sortieren einer Tabelle . <br/>
 *
 * </pre>
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner K&uuml;cker</a><br/>
 * <br/>
 *
 * @author Heiner K&uuml;cker
 * @version $Id$
 */
public class ImplicitAction
{ // implements ImplicitActionInterface {

    /**
     * setBestellPositionenToListKey-Action . <br/>
     * Liste Bestell-Positionen auf CNC_LIST_KEY legen.<br/>
     * Der Aufruf erfolgt vom {@link de.cnc.FlowControl} beim Befehl <b>&lt:action name="Bestellung#getArtikelListe"&gt;</b> in <b>flow.cnc</b>.<br/>
     *
     * @param iPaIndex Index-Nummer (Basis 0) eines indizierten Buttons oder Links
     * @param request  HttpServletRequest  des zentralen Servlets f&uuml;r Zugriff auf Session und so weiter
     * @param response HttpServletResponse des zentralen Servlets
     *
     * @return String-R&uuml;ckgabewert f&uuml;r eventuelle Auswertung
     */
    public static Object sort(//-
        final int iPaIndex, //--
        final HttpServletRequest request, //--
        final HttpServletResponse response, // --
        final CncContext cncContext)
    {
        HttpSession session = request.getSession(true);
        ArrayList arrList =
            (ArrayList) CncUtil.getList(request, ArrayList.class);

        if ("UP"
            .equals(
                CncUtil.getAttribute(session, "SORT_DIRECTION", String.class)))
        {
            ArrayListUtil.sortUp(arrList);
            session.setAttribute("SORT_DIRECTION", "DN");
            // change sort direction
        }
        else
        {
            ArrayListUtil.sortDn(arrList);
            session.setAttribute("SORT_DIRECTION", "UP");
            // change sort direction
        }
        return null;
    } // end method sort

    /**
     * -Action . <br/>
     *
     * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
     * @param response HttpServletResponse des zentralen Servlets
     *
     * @return String-Rckgabewert fr eventuelle Auswertung
     */
    public static Object debugOn(//-
        final int iPaIndex, //--
        final HttpServletRequest request, //--
        final HttpServletResponse response, // --
        final CncContext cncContext)
    {
        HttpSession session = request.getSession(true);

        session.setAttribute(SessionKeys.CNC_SINGLE_STEP_DEBUG, "ON");
        return null;
    } // end method debugOn

} // end class ImplicitAction
